$(function(){
	var oTable = new TableInit();
    oTable.Init();	
});

function deleteServer(id){
	layer.confirm('您确定要删除该记录吗?',{btn: ['确定', '取消'],title:"提示"}, function(){
        $.ajax({
            type: "post",
            url: "/mosquitto/server/delete/" + id,
            data: null,
            dataType: "json",
            async:false,
            success:function(data) {
                if(data.code == "1"){
                    layer.msg('删除成功', {icon: 1});
                    window.setTimeout("javascript:location.href='/mosquitto/server/list_page'", 1000); 
                }else{
                    layer.msg('删除失败', {icon: 2});
                }
            }
        });
    });

}

function viewDetail(id, ip, port){
	window.location.href = '/mosquitto/server/singlestatus/'+id;
}

function rowStyle(row, index) {
    if (index % 2 === 0) {
        return {
            classes: ''
        };
    }
    return {};
};

var TableInit = function () {
    var oTableInit = new Object();
    oTableInit.Init = function () {
        $('#server_list_table').bootstrapTable({
            url: '/mosquitto/server/list',
            method: 'get',
            toolbar: '#toolbar',
            striped: true,//是否显示行间隔色
            cache: false, 
            pagination: true,
            sortable: true,
            sortOrder: "asc",
            queryParams: oTableInit.queryParams,
            responseHandler: oTableInit.responseHandler,
            sidePagination: "server",
            pageNumber:1,
            pageSize: 10, 
            pageList: [10, 25, 50, 100],
            search: false,
            strictSearch: false,
            showColumns: true,
            showRefresh: true,
            minimumCountColumns: 2, 
            clickToSelect: false,
            //height: 550,
            uniqueId: "id",  
            showToggle:false,
            cardView: false,
            detailView: false,
            columns: [            	
            	{field: 'ip', title: 'IP', sortable:false, width:200},
            	{field: 'port',title: '端口',sortable:false, width:100},
            	{field: 'userName',title: '用户名',sortable:false, width:200},            	
            	{title:"操作", formatter:function(value, row, index) {
            		return "<button type='button' class='btn btn-outline btn-primary btn-xs btn-info' onclick='deleteServer(" + row.id + ")'>删除</button>" + 
            		"&nbsp;&nbsp;<button type='button' class='btn btn-outline btn-primary btn-xs btn-info' onclick='viewDetail(" + row.id + ",\"" + row.ip + "\", " + row.port + ")'>状态查询</button>";
            	}}
            	
            	]
        });
    };
    
    oTableInit.responseHandler = function(sourceData) {	
    	if (sourceData.code == "200") {
    		var pageData = sourceData.data.data;		
    		return {
    			"total": sourceData.pagination.totalCount,
    			"rows": pageData
    		}
    	} else {
    		return {
    			"total": 0,
    			"rows": []
    		}
    	}
    };    
   

    //得到查询的参数
    oTableInit.queryParams = function (params) {
        var temp = {
            limit: params.limit,
            offset: params.offset,            
            name: $.trim($("#name").val()),
            pageNumber: $('#server_list_table').bootstrapTable('getOptions').pageNumber
        };
        return temp;
    };
    return oTableInit;
};
