$(function(){  
	
	$("#search_status_btn").bind("click",function() {
		var serverId = $("#select_server_element").val();
		window.location.href="/mosquitto/server/singlestatus_chart/" + serverId;
	});
	
	$("#select_server_element").bind("change",function() {
		var serverId = $("#select_server_element").val();
		window.location.href="/mosquitto/server/singlestatus_chart/" + serverId;
	});
	
	
	for(i=0; i<s_list.length; i++ ){
		if (s_list[i].id == currentId) {
			dynamicRenderConn(s_list[i].ip, s_list[i].port, s_list[i].id, "conn");
			dynamicRenderRecMsg(s_list[i].ip, s_list[i].port, s_list[i].id, "receiveMsg");
		}
	}	                	
})


function dynamicRenderConn(ip, port, serverId, type) {
	
	var chart_zone_element = type == "conn" ? "echarts_conn_zone" : "echarts_receive_msg_zone";	
	var myChart = echarts.init(document.getElementById(chart_zone_element));
	
	var showName = type == "conn" ? "连接数" : "接收消息数";
	
	function getTodayConnectHistory(serverId) {
		var request = {url:"/mosquitto/server/conn/today/history/" + type + "/" + serverId, data:{}, type:"POST", async:false, dataType:"json"}
		return $.ajax(request).done(function(data){
			if (data.code == "200"){
				console.log(data.data);
			}else{
				console.log("get history data error!");
			}
		}).fail(function(){
			console.log('request error');
		})
	}
	 
	function getLatestedStatus() {		
		var def = $.Deferred();
		var request = {url:"/mosquitto/server/conn/today/latested/" + type + "/" + serverId, data:{}, type:"POST", async:true, dataType:"json"}
		$.ajax(request).done(function(data){
			if (data.code == "200"){				
				def.resolve([data.data.data.date, Math.round(data.data.data.value)]);
			}else{
				console.log("get history data error!");
				def.reject(null);
			}
		}).fail(function(){
			console.log('request error');
		})
		return def.promise();	   
	}

	var data = [];	
	
	getTodayConnectHistory(serverId).done(function(rData) {
		var dataList = rData.data.data; 
		$.each(dataList, function(i, item){			
			var curDate = new Date(item.date);
			data.push([item.date, Math.round(item.value)]);
		})
	})
	
	option = {
	    /*title: {
	        text: ip + ":" + port + showName
	    },*/
	    tooltip: {
	        trigger: 'axis'	        
	    },
	    xAxis: {
	        type: 'time',
	        splitLine: {
	            show: false
	        }
	    },
	    yAxis: {
	        type: 'value',
	        boundaryGap: [0, '100%'],
	        splitLine: {
	            show: false
	        }
	    },
	    
	    series: [{
	        name: showName,
	        smooth:false,
	        type: 'line',	       
	        showSymbol: false,
	        hoverAnimation: false,
	        data: data,
	        lineStyle:{
	        	normal: {
	        		color: "#3399FF",
	        		width: 1,
	        	}
	        }
	    }
	    ],
	    grid: {
	        left: '50px',
	        right: '20px',
	        top: '50px',
	        bottom: '50px'
	    }
	};

	setInterval(function () {	   
		    getLatestedStatus().done(function(appendData){
		    	if (appendData) {
		    		console.log("appendData :" + appendData[0] + "");
		    		console.log("lastData: " + data[data.length -1][0] + "");
		    		if (appendData[0] + "" == data[data.length -1][0] + "") {
		    			console.log("==date equeal, exit;");
		    			return;
		    		}
		    		if (data.length>50) {
		    		    data.shift();
		    		}
		    		data.push(appendData);	   
		    	}
		    	myChart.setOption({
		    		series: [{
		    			data: data
		    		}]
		    	});		    	
		    });
	}, 5000);

	myChart.setOption(option);	
}



function dynamicRenderRecMsg(ip, port, serverId, type) {
	
	var chart_zone_element = type == "conn" ? "echarts_conn_zone" : "echarts_receive_msg_zone";	
	var myChart = echarts.init(document.getElementById(chart_zone_element));
	
	var showName = type == "conn" ? "连接数" : "接收消息数";
	
	function getTodayConnectHistory(serverId) {
		var request = {url:"/mosquitto/server/conn/today/history/" + type + "/" + serverId, data:{}, type:"POST", async:false, dataType:"json"}
		return $.ajax(request).done(function(data){
			if (data.code == "200"){
				console.log(data.data);
			}else{
				console.log("get history data error!");
			}
		}).fail(function(){
			console.log('request error');
		})
	}
	 
	function getLatestedStatus() {		
		var def = $.Deferred();
		var request = {url:"/mosquitto/server/conn/today/latested/" + type + "/" + serverId, data:{}, type:"POST", async:true, dataType:"json"}
		$.ajax(request).done(function(data){
			if (data.code == "200"){				
				def.resolve([data.data.data.date, Math.round(data.data.data.value)]);
			}else{
				console.log("get history data error!");
				def.reject(null);
			}
		}).fail(function(){
			console.log('request error');
		})
		return def.promise();	   
	}

	var data = [];	
	
	getTodayConnectHistory(serverId).done(function(rData) {
		var dataList = rData.data.data; 
		$.each(dataList, function(i, item){			
			var curDate = new Date(item.date);
			data.push([item.date, Math.round(item.value)]);
		})
	})
	
	option = {
	    title: {
	        text: ""
	    },
	    tooltip: {
	        trigger: 'axis'	        
	    },
	    xAxis: {
	        type: 'time',
	        splitLine: {
	            show: false
	        }
	    },
	    yAxis: {
	        type: 'value',
	        boundaryGap: [0, '100%'],
	        splitLine: {
	            show: false
	        }
	    },
	    
	    series: [{
	        name: showName,
	        type: 'line',	       
	        showSymbol: false,
	        symbol:'none',
	        hoverAnimation: false,
	        data: data,
	        areaStyle: {
                normal: {
                    color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                        offset: 0,
                        color: '#98F5FF'
                    }, {
                        offset: 1,
                        color: 'rgba(125, 178, 244,1)'
                    }], false)
                }
            },
            itemStyle: {
                normal: {
                    color: '#98F5FF'
                }
            },
            lineStyle: {
                normal: {
                    width: 0
                }
            }
	        
	    }
	    ],
	    grid: {
	        left: '50px',
	        right: '20px',
	        top: '50px',
	        bottom: '50px'
	    }
	};

	myChart.setOption(option);	
	
	setInterval(function () {	   
		    getLatestedStatus().done(function(appendData){
		    	if (appendData) {
		    		console.log("appendData :" + appendData[0] + "");
		    		console.log("lastData: " + data[data.length -1][0] + "");
		    		if (appendData[0] + "" == data[data.length -1][0] + "") {
		    			console.log("==date equeal, exit;");
		    			return;
		    		}
		    		if (data.length>50) {
		    		    data.shift();
		    		}
		    		data.push(appendData);	   
		    	}
		    	myChart.setOption({
		    		series: [{
		    			data: data
		    		}]
		    	});		    	
		    });
	}, 5000);
	
	myChart.setOption(option);	
}

