$(function(){  
	
	$("#search_status_btn").bind("click",function() {
		var serverId = $("#select_server_element").val();
		window.location.href="/mosquitto/server/machine_status/" + serverId;
	});
	
	$("#select_server_element").bind("change",function() {
		var serverId = $("#select_server_element").val();
		window.location.href="/mosquitto/server/machine_status/" + serverId;
	});
	
	dynamicRenderConn(currentId);	
	              	
})

function dynamicRenderConn(serverId) {
	var chart_zone_element = "cpu_charts_div";	
	var myChart = echarts.init(document.getElementById(chart_zone_element));
	
	var showName = "CPU";
	
	function getTodayConnectHistory(serverId) {
		var request = {url:"/mosquitto/server/cpu/today/history/" + serverId, data:{}, type:"POST", async:false, dataType:"json"}
		return $.ajax(request).done(function(data){
			if (data.code == "200"){
				console.log(data.data);
			}else{
				console.log("get history data error!");
			}
		}).fail(function(){
			console.log('request error');
		})
	}
	 
	function getLatestedStatus() {		
		var def = $.Deferred();
		var request = {url:"/mosquitto/server/cpu/today/latested/" + serverId, data:{}, type:"POST", async:true, dataType:"json"}
		$.ajax(request).done(function(data){
			if (data.code == "200"){				
				def.resolve([data.data.data.date, Math.round(data.data.data.value)]);
			}else{
				console.log("get history data error!");
				def.reject(null);
			}
		}).fail(function(){
			console.log('request error');
		})
		return def.promise();	   
	}

	var data = [];	
	
	getTodayConnectHistory(serverId).done(function(rData) {
		var dataList = rData.data.data; 
		$.each(dataList, function(i, item){			
			var curDate = new Date(item.date);
			data.push([item.date, Math.round(item.value)]);
		})
	})
	
	option = {
	    /*title: {
	        text: ip + ":" + port + showName
	    },*/
	    tooltip: {
	        trigger: 'axis',
	        formatter: function(param) {
	        	return param[0].value[1] + "%";
	        }
	    },
	    xAxis: {
	        type: 'time',
	        splitLine: {
	            show: false
	        }
	    },
	    yAxis: {
	        type: 'value',
	        boundaryGap: [0, '100%'],
	        axisLabel: {
	        	formatter:function(value, index){
	        		return value.toFixed(2) + "%";
	        	}
	        },
	        splitLine: {
	            show: true
	        }
	    },
	    
	    series: [{
	        name: showName,
	        type: 'line',	       
	        showSymbol: false,
	        hoverAnimation: false,
	        data: data,
	        lineStyle:{
	        	normal: {
	        		color: "#3399FF",
	        		width: 1,
	        	}
	        }
	    }
	    ],
	    grid: {
	        left: '50px',
	        right: '20px',
	        top: '50px',
	        bottom: '50px'
	    }
	};

	setInterval(function () {	   
		    getLatestedStatus().done(function(appendData){
		    	if (appendData) {
		    		console.log("appendData :" + appendData[0] + "");
		    		console.log("lastData: " + data[data.length -1][0] + "");
		    		if (appendData[0] + "" == data[data.length -1][0] + "") {
		    			console.log("==date equeal, exit;");
		    			return;
		    		}
		    		if (data.length>50) {
		    		    data.shift();
		    		}
		    		data.push(appendData);	   
		    	}
		    	myChart.setOption({
		    		series: [{
		    			data: data
		    		}]
		    	});		    	
		    });
	}, 5000);
	
	myChart.setOption(option);	
}
